/* High Tech Drifter */
/* Copyright (c) 1988, 1990 by Jim B. Cser and Mike Roberts. */

/* GPL section */

pardon: function;
checkReach: function;
itemcnt: function;
listcont: function;
listcontcont: function;
addweight: function;
addbulk: function;
incscore: function;
darkTravel: function;
scoreRank: function;
terminate: function;
die: function;
init: function;
preinit: function;
secLeave: function;
Patalk: function;
secReturn: function;
giveBox: function;
guard2fence: function;
meterOn: function;
roboCrash: function;
WayneTalk: function;
endgame: function;
replay: function;
secChew: function;
roboCrash: function( param )
{  
    if( Me.location = courtyard and resanddev.isseen and eastfab.isseen
                  and rockroom.isseen and supply4.isseen and not robot.flag )
    {
        robot.count := robot.count + 1 ;
        if (robot.count >= 1 )
        {
            "\b\tAs you stand in the center of the courtyard,  you gradually
            become aware that several of the speeding robots are heading
            directly towards you. By the time you realize what is going on,
            you see that the robots have converged dangerously close.";
            robot.flag := true;
	    remdaemon( roboCrash, nil );
        }
    }
}
eastyard: room
    sdesc = "East Courtyard"
    ldesc = "You are in the eastern section of the courtyard in the
            Omegatron complex. There is a building to the north, and
            a door to the building to the south.  The main gate lies
            to the east, and the courtyard continues to the west.
            Up the hill, further to the west, the main building
            looms prominently."
    east = labfront
    west = courtyard
    south =
    {
        if ( rddoor1.isopen )
            return( resanddev );
        else
        {
            "The door is closed.";
            setit( rddoor1 );
            return( nil );
        }
    }
    in = ( self.south )
;
medcabinet: openable, fixeditem
    isopen = nil
    noun = 'cabinet'
    adjective = 'medicine''first-aid'
    sdesc = "medicine cabinet"
    ldesc = 
    {
        "This is a first-aid cabinet, with a red cross painted
        on its front. ";
	pass ldesc;
    }
    location = wherehouse2
;
westyard: room
    sdesc = "West Courtyard"
    ldesc = "You are in the western section of the courtyard.  A building
             lies to south, and there is a door on the building to the
             north.  To the west, the main building is uncomfortably close.
             The courtyard continues to the east."
    north =
    {
        if ( servdoor2.isopen )
            return( instruserv );
        else
        {
            "The door is closed.";
            setit( servdoor2 );
            return( nil );
        }
    }
    in = ( self.north )
    east = courtyard
    west = mainbldg
;
courtyard: room
    sdesc = "Courtyard"
    ldesc = 
    {
        "You are now in the center of the OMEGATRON courtyard.
        Beneath your feet is a giant circular marble
        slab, roughly five meters in diameter.  Surrounding the
        courtyard are a number of buildings, the most striking of
        which is the intimidating main building to the west.
        The courtyard continues to the north, south, east, and west.";
        if ( not self.isseen )
        {
            setdaemon( roboCrash, nil );
        }
    }
    roomAction( actor, v, do, prep, io ) =
    {
        if ( robot.flag and not robot.iscrashed )
        {
	    if ( v = jumpVerb or v = duckVerb )
            {
                 "\n\tAs you successfully jump out of the way at the
                 last possible instant, you hear a deafening crash behind you.
                 When the smoke clears, you can see a heap of twisted metal
                 that used to be several robots.  Scattered around the scene
                 are some official-looking memos.";
                 robot.iscrashed := true;
		 heap.moveInto( self );
		 memo1.moveInto( self );
		 memo2.moveInto( self );
		 memo3.moveInto( self );
		 exit;
            }
            else if ( not v.isSystemVerb )  // e.g., save, restore, quit, etc.
            {
                "\bSorry, you weren't fast enough.  You're toast.";
                die();
                exit;
            }
        }
    }
    north = northyard
    south = southyard
    east = eastyard
    west = westyard
;
duckVerb: deepverb
    sdesc = "duck"
    verb = 'duck'
    action( actor ) =
    {
        "Whatever for? ";
    }
;
rddoor1: mydoorway
    otherside = rddoor2
    location = eastyard
;
resanddev: room
    sdesc = "R and D Building"
    ldesc = "You are now inside the Research and Development Building.  The
             room is filled with rows of messy desks, at which engineers are
             hard at work.  On the east wall, a large OMEGATRON logo, three
             meters across, reminds everyone just whom it is they are working
             for.  There is a file cabinet next to the wall to the south,
             and a door leads to the north."
    north =
    {
        if ( rddoor2.isopen )
            return( eastyard );
        else
        {
            "The door is closed";
            setit( rddoor2 );
            return( nil );
        }
    }
    out = ( self.north )
;
rddoor2: mydoorway
    otherside = rddoor1
    location = resanddev
;
fabdoor1a: mydoorway
    otherside = fabdoor1b
    location = northyard
;
fabdoor1b: mydoorway
    otherside = fabdoor1a
    location = westfab
;
northyard: room
    sdesc = "North Courtyard"
    ldesc = "You are in the northern section of the courtyard.  Buildings
            lie to the east and west, and the courtyard continues to
            the south. There is a door to the east."
    south = courtyard
    east =
    {
        if( fabdoor1a.isopen )
            return( westfab );
        else
        {
            "The door is closed.";
            setit( fabdoor1a );
            return( nil );
        }
    }
    in = ( self.east )
;
westfab: room
    sdesc = "West Fab Corridor"
    ldesc = "You are in a clean, well-lit corridor of the Fabrication
           Building. A yellow window is on the north wall and a clear window
         is on the south wall. A door leads west, and the corridor continues
          to the east."
    west = 
    {
         if ( fabdoor1b.isopen )
              return( northyard );
	  else
	  {
	      "The door is closed.";
	       setit( fabdoor1b );
	       return( nil );
	  }
    } 	             
    east = middlefab
    out = ( self.west )
;
middlefab: room
    sdesc = "Fab Corridor"
    ldesc = "A clean, well-lit corridor. A large multi-colored chart
              adorns the wall. The corridor contnues east and west."
    west = westfab
    east = eastfab
;
windowitem: fixeditem
    verDoLookthru( actor ) = {}
    doLookthru( actor ) = { self.thrudesc; }
;
window1: windowitem
    noun = 'window'
    plural = 'windows'
    adjective = 'yellow'
    sdesc = "yellow window"
    ldesc = "A yellow plexiglas window"
    thrudesc = "Through the window you can see a number of technicians
                hard at work.  Wearing aprons over their clean-room suits,
		some are standing at long wooden tables and slicing wafers
		off the ends of germanium ingots with huge cleavers,
		while others are putting the cleaved wafers onto cookie
		sheets."
    location = westfab
;
window2: windowitem
    noun = 'window'
    plural = 'windows'
    adjective = 'clear'
    sdesc = "clear window"
    ldesc = "A clear plexiglas window"
    thrudesc = "Through the window you can see rows of washing
               machines and dryers. In various hampers are dirty clean-room
	       suits, towels, and aprons, and similar washed items are 
	       neatly folded in piles on top of a counter.  A dollar-bill
	       changer is attached to the wall inside."
    location = westfab
;
chart: fixeditem
    noun = 'sign' 'chart'
    adjective = 'slick' 'glossy' 'multi-colored'
    sdesc = "wall chart"
    ldesc = "This is a slick, glossy, multi-colored poster depicting the
             wafer fabrication process, entitled \"OMEGATRON Germanium
	     Wafers -- From Nature to You!\""
    readdesc = { self.ldesc; }	     
    location = middlefab
;
eastfab: room
    sdesc = "East Fab Corridor"
    ldesc = "A clean, well-lit corridor, with a yellow window on the
             north wall and a red window on the south wall. To the east
             is a large steel door.  The corridor continues to the west."
    west = middlefab
;
fabdoor2: mydoorway
    adjective = 'steel''large'
    sdesc = "door"
    isopen = nil
    ldesc = "This is a large steel door, emblazoned with the words
            \"AUTHORIZED PERSONNEL ONLY\" in bright red letters. A
            slot in the door seems to require some sort of card.
            Otherwise, the door appears to be quite impenetrable."
    doOpen( actor ) =
    {
        "It won't budge. ";
    }
    location = eastfab
;
slot: fixeditem
    noun = 'slot'
    sdesc = "slot"
    ldesc = "The slot is about half a centimeter wide and five
            centimeters long."
    location = eastfab
    iscontainer = true
    verIoPutIn( actor ) =
    {
        "It won't fit in the slot, and wouldn't
	do any good even if it did. ";
    }
;
window3: windowitem
    noun = 'window'
    plural = 'windows'
    adjective = 'yellow'
    sdesc = "yellow window"
    ldesc = "A yellow plexiglas window"
    thrudesc = "Inside you can see a number of technicians taking cookie
              sheets full of germainum wafers out of ovens and placing them
	      on racks to cool.  The ovens look very much like the one you
	      saw in Ma's kitchen."	      
    location = eastfab
;
window4: windowitem
    noun = 'window'
    plural = 'windows'
    adjective = 'red'
    sdesc = "red window"
    ldesc = "A red plexiglas window"
    thrudesc = "Through the window you can see technicians hard at work
              processing germainum wafers.  One worker is spreading
	      a thin film of goo on the wafers with a butterknife. 
	      Another worker is squirting globs of goo onto the wafers
	      with a pastry tube.  The rest of the technicians are sitting
	      around a circular table playing cards.  Germanium wafers 
	      are piled in center of the table and stacked in front of
	      each player."
    location = eastfab
;
rddesk: surface, fixeditem
    noun = 'desk'
    plural = 'desks'
    sdesc = "desk"
    ldesc = "The desks are covered with computers, papers, pens, and
            other rubble, completely obscuring their surfaces.  None
            of the papers are legible, much less understandable."
    location = resanddev
    issurface = true
;
deskRubble: decoration
    noun = ['rubble' 'pen' 'pens' 'computer' 'computers' 'paper' 'papers']
    sdesc = "rubble"
    ldesc = "The rubble really doesn't look that interesting. Really."
    adesc = "rubble"
    location = resanddev
;
engineer: fixeditem
    noun = 'engineer'
    plural = 'engineers'
    sdesc = "engineer"
    ldesc = "These are your canonical engineers:  white dress shirts
            with pens in the pocket, boring ties, digital watches
            that play goofy songs, and appallingly high salaries."
    location = resanddev
;
filecab: openable, fixeditem
    fixed = true
    isopen = nil
    noun = ['cabinet''drawer']
    adjective = 'file' 'metal' 'gray' 'steel'
    sdesc = "file cabinet"
    ldesc = 
    {
        "This is a normal-looking gray steel filing cabinet with
        a single drawer.  A label on the front reads \"Needless
        Paperwork\". ";
	pass ldesc;     // pick up contents list
    }
    location = resanddev
;
class formitem: readable
    plural = ['forms']
    noun = ['form']
    location = filecab
;
form1: formitem
    adjective = 'form-request'
    sdesc = "form-request form"
    ldesc = "\nFORM #2629 -- FORM REQUEST
             \bThis is a form for ordering more forms."
;
form3: formitem
    adjective = 'unusual''incident''report'
    sdesc = "unusual incident report form"
    ldesc = "\nFORM #5228 -- UNUSUAL INCIDENT REPORT
             \bThis is a form for reporting anything unusual."
;
form4: formitem
    adjective = 'normal' 'incident' 'report'
    sdesc = "normal incident report form"
    ldesc = "\nFORM #6171 -- NORMAL INCIDENT REPORT
             \bThis is a form for reporting anything normal."
;
form5: formitem
    adjective = 'coffee' 'request'
    sdesc = "coffee request form"
    ldesc = "\nFORM #4511 -- COFFEE REQUEST
            \bThis is a form for getting a cup of coffee.  It is
            used in conjunction with the CREAM AND SUGAR REQUEST form."
;
form6: formitem
    adjective = 'cream-and-sugar' 'request'
    sdesc = "cream-and-sugar request form"
    ldesc = "\nFORM #4512 -- CREAM AND SUGAR REQUEST
             \bThis is a form for getting cream and sugar for your
             coffee. It cannot be used without the COFFEE REQUEST form."
;
form7: formitem
    adjective = 'dispusion' 'meter' 'request'
    sdesc = "dispusion meter request form"
    ldesc = "\nFORM #0809 -- DISPUSION METER REQUEST
            \bThis is a form for obtaining a dispusion meter."
;
form8: formitem
    adjective = 'permission' 'nervous' 'breakdown'
    sdesc = "nervous breakdown permission form"
    ldesc = "\nFORM #7562 -- PERMISSION FOR NERVOUS BREAKDOWN
            \bThis is a form to be filed in advance of a nervous breakdown."
;
form9: formitem
    adjective = 'loyalty' 'oath'
    sdesc = "loyalty oath form"
    ldesc = "\nFORM #9999 -- LOYALTY OATH
             \bThis is a statement that you do not belong, or have
             ever belonged, to any club, society, or organization that
             would have someone like you as a member."
;
robot: robotitem
    location = courtyard
;
heap: item
    noun = ['heap''metal''rubble']
    adjective = 'twisted'
    sdesc = "heap of twisted metal"
    ldesc = "The heap is comprised of the various fragments of three
            or four different robots, none of which are now even
            recognizable, much less operational. A thin wisp of smoke
            drifts upward from the rubble. "
    doTake( actor ) =
    {
        "It's too big to move. ";
    }
    location = nirvana

;
memo1: memoitem
    adjective = 'carnation'
    sdesc = "carnation memo"
    ldesc = "\b\bInteroffice Memorandum MPU328/1A
            \bTo: All new OMEGATRON employees
	    \nFrom: Patrick J Wayne
	    \nSubject: Orientation
	    \b\tWelcome to OMEGATRON!  As new employees, you probably do not 
	    yet realize just how lucky you are to be working here.  To get
	    you into the proper frame of mind, we have scheduled mandatory
	    viewings of our short multi-media presentation entitled
	    \"The Glory of OMEGATRON\".  It's a fine piece of work, complete
	    with 70mm films, stereophonic sound, psychoactive drugs, and 
	    elaborate electronic monitoring equipment for your added enjoyment.
	    See you there!\b\b"
;
memo2: memoitem
    adjective = 'goldenrod'
    sdesc = "goldenrod memo"
    ldesc = "\b\bInteroffice Memorandum CBN402/4Q
             \bTo: All OMEGATRON engineers
	     \nFrom: M Leslie, Systems Safety Committee Chairman
	     \nSubject: RCAS1205 and You
	     \b\tRecently, while in the Fabrication Building, I was asked
	     what RCAS1205 pink plastic was.  Never having heard of the
	     material, I suspected that it was a mismarking of RCAS1200,
	     a standard packaging plastic.  I sent a small sample to the
	     Materials Lab, and the report that came back said that it had
	     1000 to 10000 times the dispusion of RCAS1200, and caused
	     any chips placed in contact with it to instantly burst into flames.
	     \n\tExactly how RCAS1205 came to be ordered is not certain, but
	     procurement records show that several rolls were ordered last 
	     summer.  All suspected rolls of plastic have been impounded
	     and sold to rival chip manufacturers.  If you have any plastic
	     that exhibits anomalously high dispusion, please dispose of it
	     immediately.  You'll be glad you did.\b\b"
;
memo3: memoitem
    adjective = 'canary'
    sdesc = "canary memo"
    ldesc = "\b\bInteroffice Memorandum ZBV816/5D
            \bTo: All OMEGATRON employees
	    \nFrom: Document Control
	    \nSubject: Updated Form Modifications (Part 4 of 10)
	    \b\tIn order to keep the OMEGATRON bureaucracy flexible, we must
	    periodically make massive, unneccesary changes at a moment's
	    notice.  The following changes are now in effect:
	    \b*  Certain forms (#0001 to #4999) will be renumbered, so that
	    we may have a new numbering system for these forms.
	    \b*  The Form Request Form (#2629) will be discontinued, due to a 
	    lack of Form Request Form Request Forms (#2630).
	    \b*  Due to excessive employee use of instruments for unusual
	    purposes, a Normal Incident Report Form (#6171) will be required
	    when submitting any Instrument Request Forms (#0800 to #0864).
	    \b*  As you read this memo, most or all of the changes listed here
	    will have been superseded.  Please refer to memo ZBV816/5E.\b\b"
;
southyard: room
    sdesc = "South Courtyard"
    ldesc = "You are in the southern section of the courtyard.  A building
             lies to the east, and there is a door on the building to
             the west.  The courtyard continues to the north."
    north = courtyard
    west =
    {
        if ( wheredoor2.isopen )
            return( wherehouse1 );
        else
        {
            "The door is closed.";
            setit( wheredoor2 );
            return( nil );
        }
    }
    in = ( self.west )
;
slab: fixeditem
    noun = 'slab'
    adjective = 'giant''marble''circular'
    sdesc = "marble slab"
    ldesc = "The slab has been hewn out of black and gray marble, and
            polished to mirror-smoothness.  The design is the OMEGATRON
            logo --  a capital letter omega inscribed within a circle --
            inlaid in black against the gray. "
    location = courtyard
;
class memoitem: readable
    noun = ['memo']
    plural = ['memos']
    location = nirvana
;
wheredoor2: mydoorway
    otherside = wheredoor1
    location = southyard
;
wherehouse1: room
    sdesc = "East Supply Warehouse"
    ldesc = "You are at the east end of a large supply warehouse. The
             walls are steel mesh, with openings to the north and south.
             Through the mesh on either side you can see a number of
             large crates. There is a door to the east."
    east =
    {
        if ( wheredoor1.isopen )
            return( southyard );
        else
        {
            "The door is closed.";
            setit( wheredoor1 );
            return( nil );
        }
    }
    out = ( self.east )
    west = wherehouse2
    north = supply1
    south = supply2
;
servdoor2: mydoorway
    location = westyard
    otherside = servdoor1
;
instruserv: room
    sdesc = "Instrument Services Building"
    ldesc = "The room is dimly-lit, and along the walls are shelves of
             broken electronic equipment: computers, printers, oscilloscopes,
             and the occasional pinball machine.  All of them are
             labeled with red tags that read \"REPAIR -- ASAP\".  You can see
             a glow to the north. A door lies to the south."
    north = rockroom
    south =
    {
        if ( servdoor1.isopen )
            return( westyard );
        else
        {
            "The door is closed.";
            setit( servdoor1 );
            return( nil );
        }
    }
    out = ( self.south )
;
servdoor1: mydoorway
    location = instruserv
    otherside = servdoor2
;
wheredoor1: mydoorway
    location = wherehouse1
    otherside = wheredoor2
;
wherehouse2: room
    sdesc = "West Supply Warehouse"
    ldesc = "You are in the west end of a large supply warehouse. The
         walls are steel mesh, through which you can see some boxes to
          the north and some rolls of pink plastic to the south.  On the
          west wall is a metal cabinet. Openings in the wall are to the
         north and south, and the warehouse continues to the east."
    east = wherehouse1
    north = supply3
    south = supply4
;
supply1: room
    sdesc = "Supply Room One"
    ldesc = "The room is full of sealed crates. There are
            openings in the wall to the west and south. "
    south = wherehouse1
    west = supply3
;
supply2: room
    sdesc = "Supply Room Two"
    ldesc = "This room contains a number of cylindrical metal drums.
            A couple of the drums are leaking, and the smell is terrible.
             An opening in the wall is to the north."
    north = wherehouse1
;
supply3: room
    sdesc = "Supply Room Three"
    ldesc = "The room is full of sealed crates. There are
            openings in the wall to the east and south. "
    south = wherehouse2
    east = supply1
;
class crate: fixeditem
    noun = ['crate' 'pile' 'crates']
    sdesc = "crates"
    adesc = "a pile of crates"
    ldesc = "The crates are various sizes and shapes, and covered with
             meaningless numbers, bar codes, and \"THIS END UP\" arrows,
             some of which are actually pointing upward."
;
crate1: crate
    location = supply1
;
crate2: crate
    location = supply3
;
drum: fixeditem
    noun = 'drums'
    plural = 'drum'
    adjective = 'metal''cylindrical'
    sdesc = "drum"
    ldesc = "The drums are a meter tall and painted black.  They are
            covered with meaningless numbers and bar codes."
    location = supply2
;
supply4: room
    sdesc = "Supply Room Four"
    ldesc = "You are in a suppply room full of rolls of pink-
            colored plastic. There is an opening in the wall to
             the north."
    north = wherehouse2
;
cotton: item
    noun = 'ball''bunch'
    plural = 'balls'
    adjective = 'cotton''white'
    sdesc = "bunch of cotton balls"
    ldesc = "A bunch of fluffy, white balls of cotton."
    location = medcabinet
;
bandaid: item
    noun = 'band-aid''ouchless''adhesive'
    sdesc = "band-aid"
    ldesc = "A standard ouchless adhesive bandage."
    location = medcabinet
;
rolls: fixeditem
    adjective = 'pink'
    noun = 'plastic''roll'
    plural = 'rolls'
    sdesc = "rolls of plastic"
    ldesc = "You see rolls and rolls of translucent pink plastic.
             They are to big to move and too tough to tear."
    location = supply4
;
equipment: decoration
    noun = ['equipment' 'printer' 'printers' 'computer' 'computers'
           'oscilloscope' 'oscilloscopes' 'machine']
    adjective = 'pinball'
    sdesc = "equipment"
    adesc = "equipment"
    ldesc = "It's quite a big pile of equipment, but, alas, all of it
             is broken beyond your ability to repair."
    location = instruserv
;
magic: deepverb
    verb = 'magic'
    action( actor, do, prep, io ) =
    {
        actor.travelTo( courtyard );
    }
;
coda: deepverb
     verb = 'coda'
     action( actor ) = 
     {
        actor.travelTo( corridor );
	gamedisk.moveInto( Me );
     }
;
wombat: deepverb
    verb = 'wombat'
    action( actor, do, prep, io ) =
    { 
        actor.travelTo( housefront );
    }
;
splunge: deepverb
    verb = 'splunge'
    action( actor, do, prep, io ) = 
    {
        eastfab.isseen := true ;
        resanddev.isseen := true ;
        rockroom.isseen := true ;
        supply4.isseen := true ;
        actor.travelTo( northyard );
    }
;
class robotitem: item
    noun = ['robot' 'bureaubot' 'swarm']
    plural = ['robots' 'bureaubots']
    sdesc = "swarm of paper-toting robots"
    ldesc = "These are the latest-model bureaubots, made of gleaming chrome 
             and titanium, and are efficiently carrying important
             documents where they need to go.  They are moving much
             too fast for you to make out many details about them."
    count = 0
    flag = nil
    iscrashed = nil
    doTake( actor ) =
    {
        "As you reach out to take the robot, it suddenly veers directly
	toward you, and instantly slams into you with tremendous force,
	killing you instantly.  The robot apolgizes profusely, lays a
	form titled \"Accidental Death or Dismemberment\" on top of
	you, and awaits your signature. ";
	die();
    }
;
northRobot: robotitem
    location = northyard
;
southRobot: robotitem
    location = southyard
;
eastRobot: robotitem
    location = eastyard
;
westRobot: robotitem
    location = westyard
;
