/* High Tech Drifter */
/* Copyright (c) 1988, 1990 by Jim B. Cser and Mike Roberts. */
// secretary section

pardon: function;
checkReach: function;
itemcnt: function;
listcont: function;
listcontcont: function;
addweight: function;
addbulk: function;
incscore: function;
darkTravel: function;
scoreRank: function;
terminate: function;
die: function;
init: function;
preinit: function;
secLeave: function;
Patalk: function;
secReturn: function;
giveBox: function;
guard2fence: function;
meterOn: function;
roboCrash: function;
WayneTalk: function;
endgame: function;
replay: function;
secChew: function;
secLeave: function( param )
{
    if ( not secretary.isasleep )
    {
        if ( Me.location = secretary.location )
            "\n\tThe secretary stands up abruptly.  \"Now where's that file?\"
	    she asks herself. ";
        if ( pencil.location = secretary )
	{
	    pencil.moveInto( desk );
	    if ( Me.location = secretary.location )
	        "She drops her pencil on the desk and storms down the
		hallway to the west. ";
	}
	else if ( Me.location = secretary.location )
	    "She goes off down the hallway to the west. ";
	
	secretary.location.contents := secretary.location.contents -
	    secretary;
	secretary.location := nil;
        setfuse( secReturn, 4, nil );
    }
}
secReturn: function( param )
{
    if ( not secretary.isasleep )
    {
        secretary.moveInto( omegalobby );
        if ( Me.location = secretary.location )
	    "\n\tThe secretary enters the room and sits down at her
	    desk. ";
	if ( secretary.location = pencil.location or pencil.location = desk )
	{
	    pencil.moveInto( secretary );
	    if ( secretary.location = Me.location )
	        "She picks up her pencil and starts chewing the eraser. ";
	}
	else if ( secretary.location = Me.location )
	{
	    "\"Now where's that pencil?\" she asks, looking straight at
	    you. ";
	    if ( pencil.isIn( Me ))
	    {
	        "\n\tThe secretary stands up and walks over to you.  Before
		you can protest, she searches your things and finds the pencil. 
		\"So, I suppose the pencil just got up on its legs and
		walked over here, is that it?\"  She gives you a particulary
		nasty look and walks back to her desk, pencil in hand. ";
		pencil.moveInto( secretary );
	    }
	    else
	    {
	        "\"Well, it must be those elves again,\" she says, looking
		accusingly at you. ";
	    }
	}
	setfuse( secLeave, 5, nil );
    }
}
omegalobby: room
    sdesc = "Lobby"
    ldesc = 
    {
        "You are in the rather plush lobby of the main building
        of OMEGATRON, whose name is clearly emblazoned across the wall.
	There is a door to the east which appears to lead outside.
	To the west is a hall leading into the building proper. 
	A large receptionist's desk is just next to the hallway. ";
    }
    east = mainbldg
    westAttempts = 0
    west = 
    {
        if ( secretary.isasleep )
	    return( stairfoot );
	else
	{
	    "\n";
	    if ( self.westAttempts = 3 )
	        "\"Look, young man,\" the secretary growls, \"I've had just
		about enough of you. If you try to go in there just one more
		time, you'll be in real trouble!\"  With this, she returns
		you to the lobby. ";
            else if ( self.westAttempts = 4 )
	        "\"I'm serious, mister! I'm calling the guard if you try
		that again!\" ";
            else if ( self.westAttempts >= 5 )
	    {
	        "\"That's it; you're history!\" the secretary yells. She
		presses a concealed button under her desk, and instantly
		(all right, within about 20 minutes) a guard appears. 
		\"Is this guy giving you a hard time, ma'am?\" the guard
		asks. \"I told you you'd be in trouble!\" the secretary
		tells you with satisfaction.  \"Now you're going to get
		it!\"\b\tIndeed you do get it. The guard takes out a
		revolver and, although inept with it, manages to shoot
		you after a few tries.";
		die();
		abort;
	    }
	    else if ( secretary.location = Me.location )
	        "The secretary rises from her desk and grabs you by the
		ear.  \"Where do you think you're going, young man!\" she
		demands, not asks, and firmly moves you back to the center
		of the room.  \"We'll have no more of that!  That area is
		strictly off limits to unauthorized personnel!\" ";
	    else
	        "You start to enter the hallway, but the secretary appears
		out of nowhere and takes hold of your ear.  \"This area is
		off limits!  Get back out in the lobby where you belong!\"
		She emits you into the lobby with a shove, and returns
		to her filing, more annoyed than ever. ";
	    self.westAttempts := self.westAttempts + 1;
	    return( nil );
	}
    }
;
secretary: Actor
    usecount = 0
    location = omegalobby
    noun = ['secretary''her']
    actorAction( v, d, p, i ) =
    {
        "The secretary gives you a particularly harsh look. \"If you don't
	mind, young man, I'm busy. Whatever it is you want I can't help
	you, and -- you know what? -- I wouldn't even if I could!\" She
	cackles";
	if ( pencil.location = secretary )
	    " and chews on the eraser of her pencil";
	". ";
	exit;
    }
    sdesc = "secretary"
    heredesc =
    {
        if ( self.isasleep )
	    "There is a secretary slumped over the desk.\n";
	else
	    "A secretary is sitting at the desk, trying to ignore you.\n";
    }
    ldesc = 
    {
	"The secretary is a woman in her early fifties.  She looks quite
	formidable. ";
	if ( self.isasleep )
	    "You deduce from her posture (i.e., the way she is slumped
	    over her desk) that she is quite unconscious. ";
	else
	{
	    "She notices you looking at her and casts a harsh glance
	    over her glasses at you. \"Don't stare, young man!\" she
	    admonishes, then she shakes her head, and looks down at her
	    papers and mutters something";
	    if ( pencil.location = secretary )
	        " as she chews on her pencil's eraser";
            ". ";
	}
    }
    isasleep = nil
;
pencil: item
    sdesc = "pencil"
    ldesc = "It's a standard number 2 soft-lead pencil. The eraser is
             all chewed up. "
    noun = 'pencil''eraser'
    location = secretary
;
desk: fixeditem, surface
    sdesc = "receptionist's desk"
    ldesc = 
    {
        "The receptionist's desk is quite large, with the word OMEGATRON
	conspicuously emblazoned across the marble top. ";
	pass ldesc;
    }
    noun = 'desk'
    adjective = 'receptionist\'s' 'large'
    location = omegalobby
;
tranq: container
    noun = 'tranquilizer' 'bottle'
    sdesc = "bottle of tranquilizer"
    ldesc = "The bottle seems to contain a liquid tranquilizer of some
            sort.  The instructions say to keep it away from children,
	    and claim that it's fast acting."
    isopen = nil
    ioPutIn( actor, do ) =
    {
        if ( do = pencil )
	{
            pencil.istranquil := true;
            "You dip the pencil into the bottle; a substantial
	    amount of the fluid appears to be absored into the eraser.
	    You remove the pencil and handle it carefully. ";
        }
	else
	{
	    caps(); do.thedesc; " won't fit in the bottle. ";
	}
	exit;
    }
    location = medcabinet
;
secChew: function( param )
{
    if ( Me.location = secretary.location )
    {
        if ( secretary.usecount = 0 )
	    "\n\tThe secretary looks at you suspiciously.  \"What do you want?
	    Well, whatever it is you're selling, we don't want any!\"  She
	    looks down at her papers, glancing up at you every few moments. ";
	else
            "\n\tThe secretary goes about her work, evidently irritated by your
	    presence here. ";
	secretary.usecount := secretary.usecount + 1;
        if ( pencil.location = secretary )
	{
	    "She chews impatiently on her pencil's eraser. ";
	    if ( pencil.istranquil )
	    {
	        "\n\tApparently, the tranquilizer is quite fast acting.  The
		secretary looks startled for a moment, and casts an accusing
		glance at you.  She immediately slumps over her desk, quite
		unconscious. ";
		secretary.isasleep := true;
		pencil.moveInto( desk );
	        remdaemon( secChew, nil );
		global.score := global.score + 6;
	    }
	}
    }
}
mainbldg: room
    sdesc = "Main Building Doorway"
    ldesc = { if (not omegadoor.isopen)
                {"This is the entrance to the main building of OMEGATRON.
                 There is no apparent way to open the door.  However, on 
	       the side of the builing next to the door, there is an
	       equilateral triangle of some kind. ";
	       }
	       else
	       {"\nThis is the entrance to the main building of OMEGATRON.
	          An equilateral triangle is on the side of the building.
		  The door is open.";
		}
            }		  
    east = westyard
    west = 
    {   if ( omegadoor.isopen )
        {   if ( not secretary.isactive)
	      {
	      secretary.isactive := true;
	      setfuse( secLeave, 5, nil );
	      setdaemon( secChew, nil );
	       }
	return(omegalobby);	   
	}
        else 
        { 
	 "\nThe door is closed.";
	   setit( omegadoor2 );
	   return( nil );
        }	       
     }
; class omegadoor: mydoorway
    isopen = nil
    doOpen( actor ) = { "You can't see any way to do that. "; }
    doClose( actor ) = { self.doOpen( actor ); }
;       omegadoor2: omegadoor
    location = mainbldg
;
omegadoor1: omegadoor
    location = omegalobby
;
triangle: fixeditem, surface
    noun = 'triangle'
    adjective = 'equilateral''stone'
    sdesc = "triangle"
    ldesc = { if (not omegadoor.isopen)
                { "\nIt is an equilateral stone triangle, about twenty-five 
                  centimeters on a side, inlaid in the side of the building.
	          You cannot read the writing on it, which appears to be
	          just a bunch of circles and short lines.";
	        }
	      else { 
	           "It appears to have been an equilateral stone triangle, 
		   about twenty-five centimeters on a side, that has just
		    exploded.  It is charred and smoking.";
		   }
             }
    ioPutOn( actor, do ) =
    {
        if ( do = rcas )
	{
            if ( not omegadoor.isopen )
            {
	        "\nAs you hold the plastic, the triangle begins
	        to smoke and spark. You pull your hand away 
		instinctively, just before the triangle bursts into
		flames.  The door slides open.";
		omegadoor.isopen := true;
		rcas.moveInto( Me );
	    }
	    else	     
	    {
	        "\nNothing happens.";
	    }
	}
	else
	{
	    "You hold << do.thedesc >> against the triangle for a moment,
	    but it doesn't seem to have any obvious effect. ";
	}
    }
location = mainbldg	     
;
