/* High Tech Drifter */
/* Copyright (c) 1988, 1990 by Jim B. Cser and Mike Roberts. */
// "The Rock" section

pardon: function;
checkReach: function;
itemcnt: function;
listcont: function;
listcontcont: function;
addweight: function;
addbulk: function;
incscore: function;
darkTravel: function;
scoreRank: function;
terminate: function;
die: function;
init: function;
preinit: function;
secLeave: function;
Patalk: function;
secReturn: function;
giveBox: function;
guard2fence: function;
meterOn: function;
roboCrash: function;
WayneTalk: function;
endgame: function;
replay: function;
secChew: function;
giveBox: function( param )
{
    local r, y, c;
    
    y := true;
    r := basket.contents;
    while (car( r ))
    {
        c := car( r );
	if ( c <> form7 and c <> form4 ) y := nil;
        r := cdr( r );
    }
    if ( form7.location = basket and form4.location = basket and y
     and not shoebox.isgiven )
    {
             "\bRock, surprisingly, diverts his attention from the
	      screen. He takes the forms out of the basket, checks
	      them over, rises out of his chair and walks over to
	      some shelves. \"SIIIGH...I dunno...What do you want with a
	      dispusion meter anyway?\" Rock says.  He takes an old shoebox
	      off the shelf and shoves it into your hands. 
	      \"I dunno. It's toast, but it's the only one I've got.
	      Deal with it yourself --  it's trivial. If you don't mind,
	      I have important things to do.  I'm way, way behind. I'll never
	      get anything done at this rate. SIIIGH...\"  Rock shakes his head
	      in disgust and sits back down at his desk to continue
	      typing away.";
	      
	      shoebox.moveInto( Me );
	      form7.moveInto( nirvana );
	      form4.moveInto( nirvana );
	      shoebox.isgiven := true;
              global.score := global.score + 6;
    }        
}
meterOn: function
{
    if( blatz.location = meter and whizzo.location = meter 
         and chip.location = meter and meter.istoast)
	  { 
	      "\nAs you place the last component in the dispusion meter,
	        it goes \"Ping!\", and lights on it begin to flash
		on and off.";
		meter.istoast := nil;
		remdaemon( meterOn, nil );
		global.score := global.score + 4;
	 }
}
rcas: item
    noun = ['square''plastic''rcas1205''rcas-1205']
    sdesc = "square of plastic"
    ldesc = "It appears to be a small square of translucent pink plastic."
    location = nirvana
; rockroom: room
    sdesc = "Rock's Office"
    ldesc = { "This room is much smaller than the first, and
             is illuminated by a single naked 100-Watt light bulb.  Sitting
            at a desk is a small yet intense man, with dark curly hair and
	    thick glasses, who is typing away furiously at large computer
	    terminal.  Every so often he lets out a prolonged, audible
	    sigh.  Piled on the desk next to the terminal are several
	    dozen empty jars of peanut butter and jelly. Also on the desk
	    is a small nameplate which reads \"Hi -- I'm Rock!\". 
	    A basket is attached to the wall nearby.  An exit leads south.";
	    if (not self.isseen)
	       { 
	         setdaemon(giveBox, nil);
	         setdaemon(meterOn, nil);
	       }
	    }
    south = instruserv
;
gooberjar: decoration
    noun = ['jar' 'jars' ]
    adjective = 'peanut''butter''jelly'
    sdesc = "jar"
    ldesc = "The jars are pretty disgusting."
    location = rockroom
; mac: decoration
    noun = ['computer''terminal''screen']
    adjective = 'computer'
    sdesc  = "computer"
    ldesc = "On the computer screen is a high resolution 256-color map
             of the Mandelbrot set."
    location = rockroom
;
rockplate: decoration
    noun = 'nameplate'
    sdesc = "nameplate"
    ldesc = "The nameplate says \"Hi -- I'm Rock!\", but is otherwise
            uninteresting."
    location = rockroom
;
Rock: Actor
    noun = ['him''rock']
    location = rockroom
    sdesc = "Rock"
    adesc = "Rock"
    thedesc = "Rock"
    ldesc = "Despite his outward characteristics, he is in reality the
             Sex God of the Eighties."
    herecnt = 0
    actorDesc =
    {
        self.herecnt := self.herecnt + 1;
        "Rock is sitting at his terminal, ";
        if ( self.herecnt = 1 )
            "attempting to rebuild a corrupt file system.\n";
        else if ( self.herecnt = 2 )
            "mumbling something to himself about how hopelessly behind
            in his work he is.\n";
        else if ( self.herecnt = 3 )
            "cracking his knuckles, muttering about the new recruits
            at Omegatron.\n";
        else
        {
            self.herecnt := 0;
            "using his calculator watch to find a rough figure for
            the number of calories required to ride up Mt. Wilson on
            a unicycle.\n";
        }
    }
    verDoAskAbout( actor, io ) = {}
    doAskAbout( actor, io ) =
    {
        "\"Hmmm,\" Rock says, not even looking up from his terminal.
        He sighs, and says distantly, \"I don't know, I don't know...\" ";
        exit;
    }
    actorAction( v, d, p, i ) =
    {
        if ( v = helloVerb )
        {
            "\"Oh, hello,\" Rock says, and continues typing at his
            terminal.\n";
        }
        else
        {
            "\"SIIIGH... Too trivial for me to even bother with,\"
             Rock grumbles.\n";
        }
        exit;
    }
    verIoGiveTo( actor ) = {}
    ioGiveTo( actor, do ) =
    {
        "Rock refuses your offer, muttering something about using proper
	procedure and his in-basket. ";
    }
;
basket: container, fixeditem
    noun = 'basket' 'in-basket'
    adjective = 'instrument' 'request'
    sdesc = "basket"
    ldesc =
    {
        "This is a plastic, wall-mounted basket made for holding
        papers that are supposed to be important.  It is labelled
        \"INSTRUMENT REQUESTS\". ";
	pass ldesc;
    }  
    location = rockroom
;
shoebox: container
    isgiven = nil
    noun = 'shoebox''box'
    adjective = 'shoe'
    sdesc = "shoebox"
    ldesc = {
              "It's an old cardboard shoebox. "; pass ldesc;
	    }
    location = nirvana	      
;
meter: container
    istoast = true
    noun = 'meter'
    adjective = 'dispusion'
    sdesc = "dispusion meter"
    ldesc =
    {
        if( meter.istoast)
        {
	    "Toasted dispusion meter. ";
            if (car(self.contents) <> nil)
	    {
	        "Its brand-new components are: ";
		listcont(self); ". ";
	    }
	}	       
	else 
	{
	    "The dispusion meter is blinking on and off, and
	     every so often goes \"Ping!\"."; 
	}
    }
    location = shoebox
;
instruct: readable
    noun = ['instructions' 'set']
    sdesc = "set of instructions"
    readdesc = { self.ldesc; }
    ldesc = "\bInstructions for repairing dispusion meter:
             \b 1. Take off this before put into the blade.
	     \n 2. Do not place on the surface that is hotter than 80 degrees.  
             \n 3. Put in a blatz, a whizzo, and a germanium chip.
	     \n 4. It is for the observation and admiration of the swelling."
    location = shoebox
;
blatz: item
    noun = 'blatz'
    sdesc = "blatz"
    location = supply1
;
whizzo: item
    noun = 'whizzo'
    sdesc = "whizzo"
    location = eastfab
; 
